// PDicReader.h: CPDicReader NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PDICREADER_H__F5DE7F34_1AE8_476A_8242_191AD454ED29__INCLUDED_)
#define AFX_PDICREADER_H__F5DE7F34_1AE8_476A_8242_191AD454ED29__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif	// _MSC_VER > 1000

#include "../BOCU1/bocu1.h"

#define EXCEPTION_CODE 0xE0000001 

#define LTWOBYTEUINT(b) ((((unsigned int)*((b)+0))<<0)+ (((unsigned int)*((b)+1))<<8))
#define LFOURBYTEUINT(b) \
	( (((unsigned int)*((b)+0))<<0	) \
	+ (((unsigned int)*((b)+1))<<8	) \
	+ (((unsigned int)*((b)+2))<<16	) \
	+ (((unsigned int)*((b)+3))<<24	))

typedef unsigned char byte;

//#define	PDIC_MAX_TITLE	248	//	oő咷
#define	PDIC_MAX_TITLE	1024	//	oő咷
#define	PDIC_MAX_HONBUN	3000	//	ő咷
#define	PDIC_MAX_YOREI	20000	//	pő咷
#define	PDIC_MAX_PHONETIC	1000	//	Lő咷

#define	PDIC_MAX_HEADER_LEN	1024	//	őwb_()
#define PDIC_MAX_BLKLEN		1024	//	őubN(Hyper`̏ꍇ)
#define	PDIC_HEADER_256		256		//	wb_()

//#define	PDIC_HEADER_LEN	256	//	wb_()
//#define PDIC_BLKLEN		256	//	ubN(Hyper`̏ꍇ)

//////////////////////////////////////////////////////////////////////
//	PDIC	wb_
//////////////////////////////////////////////////////////////////////
/*
	̃vOł́ANEWDIC3(Hyper`)T|[g
*/

// NEWDIC2

#define L_HEADERNAME 100	// wb_[
#define L_DICTITLE 40		// ^Cg

struct NEWDIC2 {
	char headername[ L_HEADERNAME ];	// wb_[^Cg
	char dictitle[ L_DICTITLE ];	// 
	short version;	// ̃o[W
	short lword;	// o̍ő咷
	short ljapa;	// ̍ő咷
	short block_size;	// PubÑoCg
	// NEWDIC2 ̏ꍇ́A/16
	short index_block;	// CfbNXubN
	short header_size;	// wb_[̃oCg
	unsigned short index_size;	// CfbNX̃oCg
	short empty_block;	// 󂫃ubN̐擪ubNԍiȂƂ-1j
	short nindex;	// CfbNX̗vf̐
	short nblock;	// gpf[^ubN
	unsigned long nword;	// o^Pꐔ
	byte dicorder;	// ̏
	byte dictype;	// ̎
	byte attrlen;	// Pꑮ̒
//#ifdef NEWDIC2
	long olenumber;	// OLE pVAԍ
	byte os;	// OS
	// ȉ̌ID ͖
	unsigned short lid_word;	// oꌾID
	unsigned short lid_japa;	// ꕔID
	unsigned short lid_exp;	// pᕔID
	unsigned short lid_pron;	// LID
	unsigned short lid_other;	// ̑ID
	// char dummy[ 84 ];	// ID gpȂƂdummy
	char dummy[ 74 ];	// ID gpƂdummy
//#else
//	char dummy[ 89 ];
//#endif
};


// NEWDIC3 4.00

struct NEWDIC3_4 {
	char headername[ L_HEADERNAME ];	// wb_[^Cg
	char dictitle[ L_DICTITLE ];	// 
	short version;	// ̃o[W
	short lword;	// o̍ő咷
	short ljapa;	// ̍ő咷
	short block_size;	// PubÑoCg(256 Œ)
	short index_block;	// CfbNXubN
	short header_size;	// wb_[̃oCg
	unsigned short index_size;	// CfbNX̃oCg(gp)
	short empty_block;	// 󂫃ubN̐擪ubNԍiȂƂ-1j
	short nindex;	// CfbNX̗vf̐(gp)
	short nblock;	// gpf[^ubN(gp)
	unsigned long nword;	// o^Pꐔ
	byte dicorder;	// ̏
	byte dictype;	// ̎
	byte attrlen;	// Pꑮ̒
	long olenumber;	// OLE pVAԍ
	byte os;	// OS
	unsigned short lid_word;	// oꌾID
	unsigned short lid_japa;	// ꕔID
	unsigned short lid_exp;	// pᕔID
	unsigned short lid_pron;	// LID
	unsigned short lid_other;	// ̑ID
	unsigned long extheader;	// gwb_[TCY
	long empty_block2;	// 󂫃ubN擪ubNԍ
	long nindex2;	// CfbNXvf̐
	long nblock2;	// gpf[^ubN
	byte index_blkbit;	// 0:16bit, 1:32bit
	byte reserved[8+1];
	unsigned long update_count;	// XV
	byte charcode;		// R[h
	char dummy[ 43 ];	// pfBO
};


// NEWDIC3 5.00

struct NEWDIC3_5 {
	char headername[ L_HEADERNAME ];	// wb_[^Cg
	char dictitle[ L_DICTITLE ];	// 
	short version;	// ̃o[W
	short lword;	// o̍ő咷
	short ljapa;	// ̍ő咷
	short block_size;	// PubÑoCg(256 Œ)
	short index_block;	// CfbNXubN
	short header_size;	// wb_[̃oCg
	unsigned short index_size;	// CfbNX̃oCg(gp)
	short empty_block;	// 󂫃ubN̐擪ubNԍiȂƂ-1j
	short nindex;	// CfbNX̗vf̐(gp)
	short nblock;	// gpf[^ubN(gp)
	unsigned long nword;	// o^Pꐔ
	byte dicorder;	// ̏
	/*
		Dicorder byte
		------------------
		0 R[h
		1 啶Eꎋ
		2  gwb_[CodeMap
		3 ~
	*/
	byte dictype;	// ̎
	/*
		0x01	AR ̈k𗘗p
		0x08	BOCU-1 ̈k𗘗p(Unicode gp̂)
		0x10	Unicode(UTF-16)gpĂ
		0x20	ꎫi폜j
		0x40	I[vɂ̓pX[hKv
				(f[^̂̂Í킯ł͂Ȃ)
		0x80	c[r[[hp̎
	*/
	byte attrlen;	// Pꑮ̒
	byte os;	// OS
	/*
		Unicode ͕K0x00*
		os		byte
		------------------
		0x00	DOS,Windows,OS/2(x86 n), sCR,LF
		0x01	Mac
		0x02	UNIX - SJIS n
		0x03	UNIX - EUC n
		0x04	UNIX - JIS n
		0x20	BOCU encoding
	*/
	long olenumber;	// OLE pVAԍ
	unsigned short lid_word;	// oꌾID
	unsigned short lid_japa;	// ꕔID
	unsigned short lid_exp;	// pᕔID
	unsigned short lid_pron;	// LID
	unsigned short lid_other;	// ̑ID
	byte index_blkbit;	//	CfbNX̕ubNԍ̃rbg(0:16bit,1:32bit)
	byte dummy0;
	unsigned long extheader;	// gwb_[TCY
	long empty_block2;	// 󂫃ubN擪ubNԍ
	long nindex2;	// CfbNXvf̐
	long nblock2;	// gpf[^ubN
	byte reserved[8];
	unsigned long update_count;	// XV
	byte dummy00[4];
	byte dicident[8];	// ʎq
	char dummy[ 32 ];	// pfBO
};


//////////////////////////////////////////////////////////////////////
//	PDIC CfbNX
//////////////////////////////////////////////////////////////////////

typedef struct  {
	unsigned long	offs;	// CfbNX擪̃ItZbg 0..
	unsigned long	blkno;	// f[^ubNԍ
	unsigned short	titlelen;	// o
} PDIC_INDEX;

class CPDicIndex
{
	NEWDIC3_5 *m_header;
	int m_pdic_ver;					// PDIC̃o[Wԍ
	PDIC_INDEX	*m_indexTbl;
	unsigned long	m_maxIndex;		// m_indexTbl[]̊

public:
	CPDicIndex( FILE*fp, NEWDIC3_5 *header);
	virtual ~CPDicIndex();
	int	LoadIndex();

	int BSearchIndex( LPCTSTR keyword );
	int	ReadRec( unsigned long idxno, unsigned long *datablk, byte*title, int *titlelen );
	FILE*	m_fp;

};

//////////////////////////////////////////////////////////////////////
//	PDIC f[^
//////////////////////////////////////////////////////////////////////
typedef struct {
	unsigned long	indexno;	// CfbNXԍ
	unsigned long	blkno;		// f[^̕ubNԍ(AubN̐擪)
	unsigned long	recOffs;	// ̍ڂ̃ubN擪̃ItZbg
	unsigned long	toffs;		// AubN̐擪̌oItZbg(kĂ)
	unsigned long	hoffs;		// AubN̐擪̖ItZbg
	unsigned long	yoffs;		// AubN̐擪̗pᕔItZbg
	unsigned long	poffs;		// AubN̐擪̔LItZbg
	unsigned short	titlelen;	// o̒
	unsigned short	honbunlen;	// ̒
	unsigned short	yoreilen;	// pᕔ̒
	unsigned short	phoneticlen;	// L̒
	short	level;				// Pꃌx
	short	fieldSize;			// 2 or 4
	int		blocks;				// gpubN
} PDIC_ITEMINFO;

class CPDicData
{  
	NEWDIC3_5 *m_header;
	int m_pdic_ver;					// PDIC̃o[Wԍ
	byte m_buffer[PDIC_MAX_BLKLEN];	// ݂̃ubN̓e
	unsigned long	m_curBlk;	// ݂̃ubNԍ
	int	m_recOffs;		// ubŇ݈ʒuim_blkbuf̐擪̃ItZbgj
	int	m_fieldSize;	//	2 or 4
	int	m_blocks;		// gpubN
	int	m_maxblocks;	// 蓖Ē̃ubN
	byte*	m_blkbuf;	// AubNێobt@	m_maxblocks*256
#if	defined(UNICODE)
	TCHAR m_lastTitle[PDIC_MAX_TITLE+1];	// Ǒo(o248ȓ)
#else
	byte m_lastTitle[PDIC_MAX_TITLE+1];	// Ǒo(o248oCgȓ)
#endif

public:
	CPDicData(FILE*fp,NEWDIC3_5 *header);
	virtual ~CPDicData();
	int	ReadBlks( unsigned long blkno );
	int	ReadRec( byte* title,	// o̓Ǐö
				int	*titlelen,	// title̒
				int	*hoffs,		// ̊JnItZbg(AubNł)
				int	*honbunlen,	// ̒
				int	*yoffs,		// p̊JnItZbg(AubNł)
				int	*yoreilen,	// p̒(Ƃ0)
				int	*poffs,		// ̊JnItZbg(AubNł)
				int	*phoneticlen,	// ̒(Ƃ0)
				int	*level,		// Pꃌx
				PDIC_ITEMINFO *pInfo = NULL
	);
	byte*GetBuffer();			// ݂̘AubÑobt@
	unsigned long GetOffs();	// ݂̘AubN擪̃ItZbg
	unsigned long GetBlkNo();	// ݂̘AubN擪ԍ
	FILE*	m_fp;

private:
	int	ReadBlk( unsigned long blkno );

};

//////////////////////////////////////////////////////////////////////
//	PDIC reader NX
//////////////////////////////////////////////////////////////////////

// v
	/*	
	_ANZX̏ꍇAo𒼑OƂ̍Ō̂lbN
	fR[h͕KAubNɍsȂ
	PAubN\ɓWJ
	*/
typedef struct {
	unsigned long	indexno;	// CfbNXԍ(Õf[^ubNǂނ߂)
	unsigned long	blkno;		// f[^̕ubNԍ(AubN̐擪)
	unsigned long	recOffs;	// ̍ڂ̃ubN擪̃ItZbg
	unsigned long	titleoffs;	// ov[̐擪̃ItZbg
	unsigned long	hoffs;		// AubN̐擪̖ItZbg
	unsigned long	yoffs;		// AubN̐擪̗pᕔItZbg
	unsigned long	poffs;		// AubN̐擪̔LItZbg
	unsigned short	titlelen;	// o̒
	unsigned short	honbunlen;	// ̒
	unsigned short	yoreilen;	// pᕔ̒
	unsigned short	phoneticlen;	// L̒
	short	level;				// Pꃌx
//	unsigned short	num;		// ubÑf[^ԍ0..	ReadRandom()Ŏgp
} PDIC_HITENT;

#define	MAX_PDIC_HITENT		1024
#define	MAX_PDIC_POOL		(16*1024)

// SŎgptO
#define	PDIC_S_TITLE	0x01
#define	PDIC_S_HONBUN	0x02
#define	PDIC_S_YOREI	0x04

class CPDicReader  
{
	FILE* m_fp;
	NEWDIC3_5 m_header;				// PDIC̃wb_(Ver5`)
	int m_pdic_ver;					// PDIC̃o[Wԍ
	unsigned long	m_seq_idxno;	// CfbNXǍ݂̌̃CfbNXԍ
	unsigned long	m_seq_datablk;	// CfbNXǍ݂̌̃f[^ubN
									// AubN̐擪

	// \
	PDIC_HITENT	*m_hitent;		// vʂi[z
	unsigned long	m_numhit;	// ŏǏ̃qbg
	unsigned long	m_max_hitent;	// m_hitent[]̊TCY

	byte*m_title_pool;			// Ɉvõv[̈
								// o͈kĂ̂ŁALʂۑ邽
	unsigned long	m_max_title_pool;	// m_title_pool̊TCY
	unsigned long	m_title_len;	// m_title_pool̍ŏIʒu

	CPDicIndex*m_pIndex;
	CPDicData*m_pData;
	int	m_bOpened;				// openς

public:
	CPDicReader();
	virtual ~CPDicReader();
	int	Open( LPCTSTR pszFilePath );
	void Close();
	int	ReOpen( LPCTSTR pszFilePath );	// t@Cnĥݍopen

	// 
	int FindFirst();	//	擪ڂɈʒut
	int ReadNext( LPTSTR keyword, LPTSTR honbun,int maxhonbun, 
			LPTSTR yorei,int maxyorei, LPTSTR phonetic,int maxphonetic,int*level,
			unsigned short (*phoneticUniMap)[256][2]  ,	PDIC_ITEMINFO *pInfo );	// ̍ڂǂ
	// L[[h
	int SearchAbs( unsigned long idxno );	// CfbNXԍw
	int SearchWord( LPCTSTR keyword, int bExact,int maxHit, int *over);	// 
	int ReadResult( int num, LPTSTR keyword, LPTSTR honbun,int maxhonbun, 
			LPTSTR yorei,int maxyorei, LPTSTR phonetic,int maxphonetic,int*level,
			unsigned short (*phoneticUniMap)[256][2] );
													// numԖڂ̌ʂ擾
	int ReadResultEnt( PDIC_HITENT*pHitent,byte*m_title_pool,
			LPTSTR keyword, LPTSTR honbun,int maxhonbun, 
			LPTSTR yorei,int maxyorei, LPTSTR phonetic,int maxphonetic,int*level,
			unsigned short (*phoneticUniMap)[256][2] );
	
	int GetHitEnt( PDIC_HITENT **hit_list, int *numhit );
	int GetHitCount();	// vԂ
	void ClearHitEnt();	// vNA

	byte* GetTextPool();
	int GetMaxText();

	// S
	int SearchFullText( LPCTSTR keyword, int maxHit, int *over, short *bAbort,
		void ( *EchoCallback )(LPVOID pParam,int count, int blks, int nRead ),
		LPVOID pParam, int flag		);	// 

	// _
	int SeekIndex( unsigned long idxno );

	unsigned long GetIndexNo();	// ݂̃CfbNXԍ
	unsigned long GetBlkNo();	// ݂̃f[^ubN擪̔ԍ
	unsigned long GetOffs();	// ݂̃f[^ubN擪̃ItZbg
	NEWDIC3_5 *GetHeader();				// PDIC̃wb_(Ver5`)
	int GetPDICVer();					// PDIC̃o[Wԍ
	void PDicDumpInfo(  char*pBuf,int maxbuf, int bCRLF);


#if	defined(UNICODE)
	int MapPhoneticUni( LPCTSTR src,int slen, LPTSTR dest, int maxdest,unsigned short (*CMap)[256][2]  );
	int MapPhoneticUni( byte* src,int slen, LPTSTR dest, int maxdest,unsigned short (*CMap)[256][2]  );
#endif

//	int ReadRandom( int blkno, int num, LPTSTR keyword, LPTSTR honbun,int maxhonbun, 
//			LPTSTR yorei,int maxyorei, LPTSTR phonetic,int maxphonetic,int*level );

};

#endif	// !defined(AFX_PDICREADER_H__F5DE7F34_1AE8_476A_8242_191AD454ED29__INCLUDED_)

