// pdicminiDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "pdicmini.h"
#include "pdicminiDlg.h"
#include "../EBLib/PDicReader.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//	helper function
/////////////////////////////////////////////////////////////////////////////

void ReleaseControl()
{
		MSG message;
		if ( ::PeekMessage(&message,NULL,0,0,PM_REMOVE)) {
			::TranslateMessage(&message);
			::DispatchMessage(&message);
		}
		Sleep( 0 );	// D揇ʂ̃XbhΏ
}

// UTF16 -> UTF-8
// ߂l̓oCg
int Utf16ToUtf8(WCHAR* Src, 
				DWORD dwSizeSrc,	// Src̕(oCgł͂Ȃ)
				BYTE* pwDest)
{
	DWORD i = 0;
	int nBytes	= 0;
	DWORD data;

	for ( i=0;i < dwSizeSrc; ++i ){
		if (pwDest){	
			if ( Src[i] < 0x80 ) {
				pwDest[nBytes++] = (BYTE)Src[i];
			}
			else if ( Src[i] < 0x800 ) {
				data = (Src[i] & 0x07C0)<<2;
				data |= (Src[i] & 0x003F);
				data |= 0xc080;
				pwDest[nBytes++] = (BYTE)(data>>8);
				pwDest[nBytes++] = (BYTE)(data & 0xff);
			}
			else {
				data = (Src[i] & 0xF000)<<4;
				data |= (Src[i] & 0x0FC0)<<2;
				data |= (Src[i] & 0x003F);
				data |= 0xe08080;
				pwDest[nBytes++] = (BYTE)( (data & 0xff0000)>>16 );
				pwDest[nBytes++] = (BYTE)( (data & 0xff00)>>8 );
				pwDest[nBytes++] = (BYTE)( data & 0xff );
			}
		}
		else {
			if ( Src[i] < 0x80 ) {
				++nBytes;
			}
			else if ( Src[i] < 0x800 ) {
				nBytes += 2;
			}
			else {
				nBytes += 3;
			}
		}
	}
	return nBytes;
}

void MakeLogFont( LOGFONT* Logfont, int size, LPCTSTR faceName,
						   int bBOLD, int bITALIC, int bUnderLine, int bClearType )
{
									//tHg
	Logfont->lfHeight		= size;
	Logfont->lfWidth		= 0; //
	Logfont->lfEscapement	= 0; //eLXg̊px
	Logfont->lfOrientation	= 0; //x[XCƂƂ̊px
	if ( bBOLD ) 
		Logfont->lfWeight		= FW_BOLD; //tHg̏dij
	else
		Logfont->lfWeight		= FW_DONTCARE; //tHg̏dij
	Logfont->lfItalic		= bITALIC; //C^bN
	Logfont->lfUnderline	= bUnderLine; //A_[C
	Logfont->lfStrikeOut	= FALSE; //ł
	Logfont->lfCharSet		=  DEFAULT_CHARSET ; //Zbg
	Logfont->lfOutPrecision	= OUT_DEFAULT_PRECIS; //o͐x
	Logfont->lfClipPrecision	= CLIP_DEFAULT_PRECIS; //NbsOx
	if ( bClearType ) 
		Logfont->lfQuality		= 5;	/*CLEARTYPE_QUALITY*/
	else
		Logfont->lfQuality		= DEFAULT_QUALITY; //o͕i
	Logfont->lfPitchAndFamily= DEFAULT_PITCH; //sb`ƃt@~[
	_tcscpy(Logfont->lfFaceName, faceName );//̖

}

// pX̃t@C擾
CString GetFileName(CString path) 
{
	int p;
	if ( (p = path.ReverseFind( '\\' )) == -1 )
		if ( (p = path.ReverseFind( '/' )) == -1 )
			return path;
	return path.Right(path.GetLength()-p-1);
}


/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPdicminiDlg _CAO

CPdicminiDlg::CPdicminiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPdicminiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPdicminiDlg)
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_szFilePath[0]	= '\0';


	m_reader	= new CPDicReader();
	m_opened	= false;


}

CPdicminiDlg::~CPdicminiDlg()
{
	m_font.DeleteObject();

	delete m_reader;
}

void CPdicminiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPdicminiDlg)
	DDX_Control(pDX, IDC_KEYWORD, m_keywordCtl);
	DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Control(pDX, IDC_EDIT1, m_edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPdicminiDlg, CDialog)
	//{{AFX_MSG_MAP(CPdicminiDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SEARCH_WORD, OnSearchWord)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_NOTIFY(NM_CLICK, IDC_LIST, OnClickList)
	ON_COMMAND(ID_EXPORT, OnExport)
	ON_COMMAND(ID_DUMPINFO, OnDumpInfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPdicminiDlg bZ[W nh

BOOL CPdicminiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB

	LoadProfile();

	LOGFONT lf = {0};
	MakeLogFont( &lf, 16/*dot*/, m_fontName, /*BOLD=*/FALSE, /*ITALIC=*/FALSE,/**/FALSE, /*ClearType=*/FALSE );
	m_font.CreateFontIndirect(&lf);

	TCHAR title[][20]	= {
		_T("No."),
		_T("title"),
		_T("L"),
	};

	CListCtrl* pList = (CListCtrl*)(GetDlgItem(IDC_LIST));
	int	width[]	= {70,240,30};
	int fmt[] = {LVCFMT_LEFT,LVCFMT_LEFT};
	LV_COLUMN listcol;
	listcol.mask	= LVCF_TEXT|LVCF_FMT|LVCF_WIDTH ;
	for ( int i=0; i<3;i++) {
		listcol.pszText	= title[i];
		listcol.fmt	= fmt[i];
		listcol.cx	= width[i];
		pList->InsertColumn(i,&listcol);
	}
	// gX^C̐ݒ
	DWORD dStyle = pList->GetExtendedStyle();
	dStyle |= LVS_EX_FULLROWSELECT;	// sI
	dStyle |= LVS_EX_GRIDLINES;	// Obh\
	pList->SetExtendedStyle( dStyle );

	pList->SetFont( &m_font );
	m_edit.SetFont( &m_font );
	m_keywordCtl.SetFont( &m_font );

	// t@Copen
	if ( !m_opened && m_szFilePath[0] ) {
		if ( m_reader->Open( m_szFilePath ) != 0 ) {
			m_szFilePath[0]	= '\0';
		}
		else {
			m_opened	= true;
			ShowDictName();
		}
	}

	m_keywordCtl.SetFocus();


	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CPdicminiDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CPdicminiDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CPdicminiDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CPdicminiDlg::DestroyWindow() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ

	SaveProfile();
	
	return CDialog::DestroyWindow();
}

BOOL CPdicminiDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ

    // vXgł̃J[\L[ōڕ\
	if(pMsg->message == WM_KEYUP && pMsg->hwnd == m_list.GetSafeHwnd()) 
    { 
		DoShowItem();	// ݑIĂ鍀ڂ̕\
        return TRUE; // handled... 
    } 
	
	return CDialog::PreTranslateMessage(pMsg);
}

/////////////////////////////////////////////////////////////
// PDICJ
/////////////////////////////////////////////////////////////
static TCHAR BASED_CODE szFilterTxt[] = _T("Txt Files|*.txt|All Files (*.*)|*.*||");
static TCHAR BASED_CODE szFilterDic[] = _T("Dic Files|*.Dic|All Files (*.*)|*.*||");
void CPdicminiDlg::OnFileOpen() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CFileDialog* fileDlg
		= new CFileDialog( TRUE, NULL, _T("*.DIC"), NULL, szFilterDic, NULL );

	if ( m_opened ) {
		m_reader->Close();
		m_opened	= false;
	}

	if ( fileDlg->DoModal() == IDOK ) {
		_tcscpy( m_szFilePath, fileDlg->GetPathName() );
		if ( m_reader->Open( m_szFilePath ) != 0 ) {
			m_szFilePath[0]	= '\0';
		}
		else {
			m_opened	= true;
			ShowDictName();
		}
	}
	delete fileDlg;

}

// t@CECh[^Cgɕ\
void CPdicminiDlg::ShowDictName()
{
	SetWindowText( _T("PDIC mini - ") + GetFileName( m_szFilePath ) );
}

/////////////////////////////////////////////////////////////
// s
/////////////////////////////////////////////////////////////
void CPdicminiDlg::OnSearchWord() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( !m_szFilePath[0] ) {
		return;
	}

	if ( m_opened ) {
		DoSearch();
	}
}

/////////////////////////////////////////////////////////////
// ̎s
/////////////////////////////////////////////////////////////
void CPdicminiDlg::DoSearch()
{
	TCHAR keyword[256];
	TCHAR title[PDIC_MAX_TITLE+1];
	TCHAR honbun[PDIC_MAX_HONBUN+1];
	TCHAR yorei[PDIC_MAX_YOREI+1];
	TCHAR phonetic[PDIC_MAX_PHONETIC+1];
	int	level;
	TCHAR buf[255];
	int	over;

	m_keywordCtl.GetWindowText( keyword, 256);
	m_list.DeleteAllItems();

	int nmatch = m_reader->SearchWord( keyword,false,10000,&over);

	for ( int i=0; i<nmatch; ++ i ) {
		if ( m_reader->ReadResult( i, title, honbun, PDIC_MAX_HONBUN,
										yorei,PDIC_MAX_YOREI,
										phonetic,PDIC_MAX_PHONETIC,
										&level,NULL ) != 0 ) 
			break;
		// PDIC/Unicode Ή ; \t\
		if ( m_reader->GetPDICVer() >= 6 ) {
			int ix;
			for ( ix=0;ix<PDIC_MAX_TITLE;++ix ) {
				if ( title[ix] == 0x09 ) {
					_tcscpy( title,title+ix+1);
					break;
				}
			}
		}
		_stprintf( buf,_T("%d"),i+1 );
		m_list.InsertItem( i, buf  );
		m_list.SetItemText( i,1, title  );
		if ( level>0 ) {
			_stprintf( buf,_T("%d"),level );
			m_list.SetItemText( i,2, buf  );
		}
	}

	if ( nmatch>0 ) {
		// 擪ڂI
		m_list.SetSelectionMark(0);
		m_list.SetItemState( 0, LVIS_FOCUSED | LVIS_SELECTED , LVIS_FOCUSED | LVIS_SELECTED  );
		m_list.SetFocus();

		DoShowItem();
	}


	AddKwdHistory( keyword );

}

/////////////////////////////////////////////////////////////
// ʈꗗ̍ڑI
/////////////////////////////////////////////////////////////
void CPdicminiDlg::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	DoShowItem();	// ݑIĂ鍀ڂ̕\
	*pResult = 0;
}

// ݑIĂ鍀ڂ̕\
void	CPdicminiDlg::DoShowItem()
{
	TCHAR title[PDIC_MAX_TITLE+1];
	TCHAR honbun[PDIC_MAX_HONBUN+1];
	TCHAR yorei[PDIC_MAX_YOREI+1];
	TCHAR phonetic[PDIC_MAX_PHONETIC+1];
	int	level;
	POSITION pos;
	int iItem;


	pos = m_list.GetFirstSelectedItemPosition();
	if (pos != NULL) {
		iItem = m_list.GetNextSelectedItem(pos);

	
		m_edit.SetSel( 0, -1 );

		if ( m_reader->ReadResult( iItem, 
									title,
									honbun, PDIC_MAX_HONBUN,
									yorei,PDIC_MAX_YOREI,
									phonetic,PDIC_MAX_PHONETIC,&level,NULL ) == 0 ) {

			// PDIC/Unicode Ή ; \t\
			if ( m_reader->GetPDICVer() >= 6 ) {
				int ix;
				for ( ix=0;ix<PDIC_MAX_TITLE;++ix ) {
					if ( title[ix] == 0x09 ) {
						_tcscpy( title,title+ix+1);
						break;
					}
				}
			}

			m_edit.ReplaceSel( title );
			m_edit.ReplaceSel( _T("\r\n") );
			m_edit.ReplaceSel( honbun );
			m_edit.ReplaceSel( _T("\r\n") );
			if ( yorei[0] ) {
				m_edit.ReplaceSel( yorei );
				m_edit.ReplaceSel( _T("\r\n") );
			}
		}

		m_edit.SetSel( 0, 0 );

	}
}	

/////////////////////////////////////////////////////////////
// f[^̃_v
/////////////////////////////////////////////////////////////
void CPdicminiDlg::OnExport() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	TCHAR	szFilePath[_MAX_PATH+1];

	CFileDialog* fileDlg
		= new CFileDialog( FALSE, NULL, _T("*.txt"), NULL, szFilterTxt, NULL );

	if ( fileDlg->DoModal() == IDOK ) {
		_tcscpy( szFilePath, fileDlg->GetPathName() );
		DumpIt( szFilePath );
	}
}

void CPdicminiDlg::DumpIt( TCHAR *pszFilePath )
{
	TCHAR title[PDIC_MAX_TITLE+1];
	TCHAR honbun[PDIC_MAX_HONBUN+1];
	TCHAR yorei[PDIC_MAX_YOREI+1];
	TCHAR phonetic[PDIC_MAX_PHONETIC+1];
	int	level;
	PDIC_ITEMINFO info;

	ASSERT(m_reader);

	FILE	*fp	= _tfopen( pszFilePath, _T("wb") );
	if ( m_reader->FindFirst() != 0 ) 
		return;

	int	datacount	= 0;
	while ( m_reader->ReadNext( title, honbun, PDIC_MAX_HONBUN,
									yorei,PDIC_MAX_YOREI,
									phonetic,PDIC_MAX_PHONETIC,
									&level, NULL, &info) == 0 ) {
		// PDIC/Unicode Ή ; \t\
		if ( m_reader->GetPDICVer() >= 6 ) {
			int ix;
			for ( ix=0;ix<PDIC_MAX_TITLE;++ix ) {
				if ( title[ix] == 0x09 ) {
					_tcscpy( title,title+ix+1);
					break;
				}
			}
		}

		ReleaseControl();

		fprintf( fp,"[index=%d data=%d:%d]\n", 
				info.indexno,
				info.blkno, 
				info.recOffs
				);

#if defined(UNICODE)
		byte buffer[PDIC_MAX_YOREI];
		int nChar;
		nChar	= Utf16ToUtf8(title, _tcslen(title), buffer);
		ASSERT( PDIC_MAX_YOREI>nChar ) ;
		if (nChar== 0)	continue;
		buffer[nChar]	= '\0';
		fprintf( fp, "%s\n", buffer );

		nChar	= Utf16ToUtf8(honbun, _tcslen(honbun), buffer);
		ASSERT( PDIC_MAX_YOREI>nChar ) ;
		if (nChar== 0)	continue;
		buffer[nChar]	= '\0';
		fprintf( fp, "%s", buffer );

		nChar	= Utf16ToUtf8(yorei, _tcslen(yorei), buffer);
		ASSERT( PDIC_MAX_YOREI>nChar ) ;
		buffer[nChar]	= '\0';
		if (nChar> 0) {
			fprintf( fp, " / %s", buffer );
		}
		fprintf( fp, "\n" );

#else
		fprintf( fp, "%s\n", title );
		fprintf( fp, "%s", honbun );
		if ( yorei[0] ) {
			fprintf( fp, " / %s\n", yorei );
		}
		fprintf( fp, "\n" );
#endif

		if ( info.indexno>10000 ) {
			break;
		}

		++datacount;

		if ( datacount % 1000 == 0 ) {
			char line[255];
			sprintf( line,"%d / %d (%d%%)",
				datacount,
				m_reader->GetHeader()->nword ,
				datacount*100/m_reader->GetHeader()->nword  );
			SetWindowText( CString(line) );
		}

	}
	fclose( fp );
	ShowDictName();

}


/////////////////////////////////////////////////////////////
// wb_̕\
/////////////////////////////////////////////////////////////
void CPdicminiDlg::OnDumpInfo() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ

	char buffer[2048];

	m_reader->PDicDumpInfo( buffer,2048,TRUE);

	m_edit.SetSel( 0, -1 );
	CString s = CString(buffer);
	m_edit.ReplaceSel( s );

}

/////////////////////////////////////////////////////////////
//	̕ۑEA
/////////////////////////////////////////////////////////////

//	ǂݍ
void CPdicminiDlg::LoadProfile() 
{
	CString s;
	s = AfxGetApp()->GetProfileString(_T("Globals"),_T("FilePath"),_T(""));
	_tcscpy( m_szFilePath, s );

	m_searchWordList = AfxGetApp()->GetProfileString(_T("Globals"),_T("SearchWordList"),_T(""));
	m_fontName = AfxGetApp()->GetProfileString(_T("Globals"),_T("fontName"),_T("MS UI Gothic"));
	
}

//	ۑ
void CPdicminiDlg::SaveProfile() 
{
	AfxGetApp()->WriteProfileString(_T("Globals"),_T("FilePath"),	m_szFilePath);
	AfxGetApp()->WriteProfileString(_T("Globals"),_T("SearchWordList"),	m_searchWordList);
	AfxGetApp()->WriteProfileString(_T("Globals"),_T("fontName"),	m_fontName);

}




//////////////////////////////////////////////////////////////////////////////////
//	ꗚ
//////////////////////////////////////////////////////////////////////////////////

// ɕǉ
void CPdicminiDlg::AddKwdHistory( CString str )
{
	// ̗ɒǉ
	int idx;

	if ( str != "" ) {
		// 擪ɒǉ
		idx = m_keywordCtl.FindStringExact( -1, str );
		if ( idx != LB_ERR ) {
			m_keywordCtl.DeleteString( idx );
		}
		m_keywordCtl.InsertString( 0, (LPCTSTR)str );
		m_keywordCtl.SetCurSel( 0 );
	}

}

// AhXo[o^
void CPdicminiDlg::LoadKwdHistory()
{
	// ̗ɓo^

	m_keywordCtl.ResetContent();
	CString str = m_searchWordList;
	int i = 0;	// o^ꐔ
	while ( i<MAX_KWD_HIST && str!="" ) {
		CString w = str.SpanExcluding( _T("\t"));	// TAB̎O܂ł̕
		if ( w==_T("") ) 
			break;
		str = str.Right( str.GetLength() - w.GetLength() - 1 );
											// 菜
		if ( m_keywordCtl.FindStringExact( -1, (LPCTSTR)w ) == LB_ERR ) {
			m_keywordCtl.AddString( (LPCTSTR)w );
			++i;
		}
	}

}

// ̗̕ۑ
void CPdicminiDlg::SaveKwdHistory()
{

	TCHAR str[256];
	int idx;

	CString addrList = _T("");
	for ( idx=0; idx < min(MAX_KWD_HIST,m_keywordCtl.GetCount()); idx++ ) {
		if ( m_keywordCtl.GetLBTextLen( idx ) < 256 ) {
			m_keywordCtl.GetLBText( idx, str );
			addrList	= addrList	+CString(str)+_T("\t");
		}
	}
	m_searchWordList	= addrList;

}

