// pdicminiDlg.h : wb_[ t@C
//

#if !defined(AFX_PDICMINIDLG_H__F865C53D_0E71_4A88_9F84_CB2F1F3BB5BF__INCLUDED_)
#define AFX_PDICMINIDLG_H__F865C53D_0E71_4A88_9F84_CB2F1F3BB5BF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../EBLib/PDicReader.h"

/////////////////////////////////////////////////////////////////////////////
// CPdicminiDlg _CAO

#define	MAX_KWD_HIST	100

class CPdicminiDlg : public CDialog
{
	CPDicReader*	m_reader;
	bool	m_opened;
	CFont m_font;

	TCHAR	m_szFilePath[_MAX_PATH+1];	// t@CpX
	CString	m_searchWordList;	// ꗚ
	CString	m_fontName;	// tHg

// \z
public:
	CPdicminiDlg(CWnd* pParent = NULL);	// W̃RXgN^
	~CPdicminiDlg();
	void DoSearch();	// ̎s
	void DumpIt( TCHAR *pszFilePath );	// t@C_v
	void DoShowItem();		// ݑIĂ鍀ڂ̕\
	void LoadProfile() ;	// WXg̓ǂݍ
	void SaveProfile() ;	// WXg̕ۑ
	void ShowDictName();	// ^CgɎ\
	void AddKwdHistory( CString str );	// ɕǉ
	void LoadKwdHistory();	// AhXo[o^
	void SaveKwdHistory();	// ̗̕ۑ

// _CAO f[^
	//{{AFX_DATA(CPdicminiDlg)
	enum { IDD = IDD_PDICMINI_DIALOG };
	CComboBox	m_keywordCtl;
	CListCtrl	m_list;
	CEdit	m_edit;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CPdicminiDlg)
	public:
	virtual BOOL DestroyWindow();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CPdicminiDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSearchWord();
	afx_msg void OnFileOpen();
	afx_msg void OnClickList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnExport();
	afx_msg void OnDumpInfo();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_PDICMINIDLG_H__F865C53D_0E71_4A88_9F84_CB2F1F3BB5BF__INCLUDED_)
